import javax.swing.*;
import java.awt.*;
import java.io.*;
import java.nio.charset.StandardCharsets;

public class EditFrame extends JFrame {

    public EditFrame(String title, String fileName) {
        setTitle(title);
        setSize(300,300);
        setIconImage(new ImageIcon("icon.jpg").getImage());

        File file = new File(fileName);

        JTextArea jta = new JTextArea();
        jta.setLineWrap(true);

        try (BufferedReader reader = new BufferedReader(new InputStreamReader(new FileInputStream(file), StandardCharsets.UTF_8))) {
            String tmp;
            StringBuilder sb = new StringBuilder();
            while ((tmp = reader.readLine()) != null) {
                sb.append(tmp).append("\n");
            }
            jta.setText(sb.toString());
        } catch (Exception e){
            e.printStackTrace();
        }

        JPanel bottom = new JPanel();
        JButton ok = new JButton("确认");
        ok.setBackground(Color.white);
        JButton cancel = new JButton("取消");
        cancel.setBackground(Color.white);
        bottom.add(ok);
        bottom.add(cancel);

        setLocationRelativeTo(null);
        getContentPane().add(jta, BorderLayout.CENTER);
        getContentPane().add(bottom, BorderLayout.SOUTH);
        setDefaultCloseOperation(JFrame.DISPOSE_ON_CLOSE);

        ok.addActionListener(e -> {
            try (FileWriter writer = new FileWriter(file, StandardCharsets.UTF_8)){
                writer.write(jta.getText());
                writer.flush();
                NewsComparator.reloadConfig();
                NewsPredicate.reloadConfig();
            } catch (IOException ioException) {
                ioException.printStackTrace();
            }
            dispose();
        });
        cancel.addActionListener(e -> dispose());
    }
}
