import java.io.*;
import java.nio.charset.StandardCharsets;
import java.util.Comparator;
import java.util.HashMap;
import java.util.Map;

/**
 * 新闻比较器：用于筛选出高价值的新闻
 */
public class NewsComparator implements Comparator<OneNews> {

    public static String[] valueInits;
    /*= new String[]{
            "救","华春莹", "外交部", "雨", "雪"
    };*/

    static {
        reloadConfig();
    }

    public static void reloadConfig(){
        File file = new File("order.txt");

        if (!file.exists()) {
            try {
                file.createNewFile();
            } catch (IOException ioException) {
                ioException.printStackTrace();
            }
        }

        try (BufferedReader reader = new BufferedReader(new InputStreamReader(new FileInputStream(file), StandardCharsets.UTF_8))) {
            String tmp;
            StringBuilder sb = new StringBuilder();
            while ((tmp = reader.readLine()) != null) {
                sb.append(tmp).append("\n");
            }
            valueInits = sb.toString().split(",");
        } catch (Exception e){
            e.printStackTrace();
        }
    }

    @Override
    public int compare(OneNews o1, OneNews o2) {
        return o2.getValue() - o1.getValue();
    }
}
