import java.io.*;
import java.nio.charset.StandardCharsets;
import java.util.function.Predicate;

/**
 * 新闻过滤器：用于过滤无意义的 与 令人反感的新闻
 */
public class NewsPredicate implements Predicate<OneNews> {

    public static String[] banKeys;
    /*= new String[]{
         // 社会类
            "房", "彩礼", "单身",
         // 无意义炒作
            "火了", "专家", "谣言", "彩票",
         // 人物类
            "张艺谋", "郭德纲", "贾玲"
    };*/

    static {
        reloadConfig();
    }

    public static void reloadConfig(){
        File file = new File("banned.txt");

        if (!file.exists()) {
            try {
                file.createNewFile();
            } catch (IOException ioException) {
                ioException.printStackTrace();
            }
        }

        try (BufferedReader reader = new BufferedReader(new InputStreamReader(new FileInputStream(file), StandardCharsets.UTF_8))) {
            String tmp;
            StringBuilder sb = new StringBuilder();
            while ((tmp = reader.readLine()) != null) {
                sb.append(tmp).append("\n");
            }
            banKeys = sb.toString().split(",");
        } catch (Exception e){
            e.printStackTrace();
        }
    }

    @Override
    public boolean test(OneNews oneNews) {
        if (banKeys.length == 1 && banKeys[0].equals("")) return true;
        for (String banKey : banKeys) {
            // 如果存在禁词，则拒绝此条
            if (oneNews.getTitle().contains(banKey)){
                return false;
            }
        }
        // 无禁词，默认通过
        return true;
    }

}
